import rhVRay as vray
import Rhino.UI
import Eto.Drawing as drawing
import Eto.Forms as forms
import threading
import os.path

mutex = threading.Lock()
anim_range = [0,100]
out_file = "D:\\bongo3\\myfile.png"

class AbortDialog(forms.Form):
    abort = False

    def __init__(self):
        self.Title = 'Bongo animation running'
        self.Padding = drawing.Padding(20)
        self.Resizable = False
        self.Size = drawing.Size(300,100)
        self.Cancel = forms.Button(Text = 'Cancel')
        self.Cancel.Click += self.OnCloseButtonClick
        
        layout = forms.DynamicLayout()
        layout.Spacing = drawing.Size(5, 5)
        layout.AddRow(self.Cancel)
        self.Content = layout

    def OnCloseButtonClick(self, sender, e):
        sender.Enabled = False
        mutex.acquire()
        vray.CancelRender()
        self.abort = True
        mutex.release()

def StartRendering():
    abortDialog = AbortDialog()
    abortDialog.Owner = Rhino.UI.RhinoEtoApp.MainWindow
    abortDialog.Show()
    file_path, ext = os.path.splitext(out_file)
    for i in range(anim_range[0], anim_range[1]):
        mutex.acquire()
        stop = abortDialog.abort
        mutex.release()
        
        if stop:
            break
        
        Rhino.RhinoApp.RunScript("-_BongoSetCurrentTick %d"%i, True)
        vray.Render(0,0,-1)
        Rhino.RhinoApp.RunScript("-_SaveRenderWindowAs \"%s_%04d%s\""%(file_path, i, ext), True)
    abortDialog.Close()

StartRendering()